=== debian/changelog ===
whisper.cpp (1.7.6+dfsg-1) experimental; urgency=medium

  * Team upload.

  * New upstream version 1.7.6+dfsg
    - Introduce DFSG-cleaning for upstream source
  * Refresh / drop obsolete patches
  * Add 2030-workarounds-for-DFSG-cleaning.patch
  * d/rules: Use system ggml
  * Add dependency on libggml
  * Update d/copyright
  * De-duplicate short descriptions
  * Bump Standards-Version to 4.7.2 (no changes needed)
  * Drop dependency on libclblast-dev
  * Update upstream URLs
  * Install AUTHORS file
  * Disable tests ending license question of samples

 -- Christian Kastner <ckk@debian.org>  Sat, 21 Jun 2025 11:16:51 +0200

whisper.cpp (1.7.4-2) unstable; urgency=medium

  * Extended debian/copyright a bit based on feedback from lrc.
  * Adjust d/copyright, fix a typo and make it more specific.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 18 Apr 2025 23:30:49 +0200

whisper.cpp (1.7.4-1) unstable; urgency=medium

  * Initial release (Closes: #1064101).

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 08 Mar 2025 12:28:21 +0100
