=== debian/control ===
Source: whisper.cpp
Section: libs
Priority: optional
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Petter Reinholdtsen <pere@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libsdl2-dev,
               libggml-cpu (= 0.0~git20250618.9e4bee1-1),
Standards-Version: 4.7.2
Homepage: https://github.com/ggml-org/whisper.cpp/
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/deeplearning-team/whisper.cpp.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/whisper.cpp

Package: whisper.cpp
Architecture: any
Multi-Arch: foreign
Depends: libggml-cpu (= 0.0~git20250618.9e4bee1-1) |
                libggml-backend (= 0.0~git20250618.9e4bee1-1),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Automatic speech recogniztion and transcibing
 Port of OpenAI's Whisper automatic speech recogniztion model in C/C++ as
 a shared library, with both CPU and GPU support.

Package: libwhisper-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libwhisper1 (= ${binary:Version})
Description: Automatic speech recogniztion and transcibing - development files
 Port of OpenAI's Whisper automatic speech recogniztion model in C/C++ as
 a shared library, with both CPU and GPU support.
 .
 Headers and development files.

Package: libwhisper1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Automatic speech recogniztion and transcibing - library
 Port of OpenAI's Whisper automatic speech recogniztion model in C/C++ as
 a shared library, with both CPU and GPU support.
 .
 Shared library.
