## whisper.cpp 1.8.0

=== debian/changelog ===
whisper.cpp (1.8.0-1) unstable; urgency=medium

  * Align package names with Debian official

 -- Mathieu Baudier <mbaudier@argeo.org>  Sat, 18 Oct 2025 10:47:56 +0000
 
