## whisper.cpp 1.8.2

=== debian/changelog ===
whisper.cpp (1.8.2-1) unstable; urgency=medium

  * Update upstream

 -- Mathieu Baudier <mbaudier@argeo.org>  Tue, 11 Nov 2025 09:31:12 +0000
