## whisper.cpp 1.8.2+dfsg

=== debian/changelog ===
whisper.cpp (1.8.2+dfsg-4) unstable; urgency=medium

  * Bump Standards-Version to 4.7.3
    - Drop Priority: optional, it's the dpkg default since trixie
  * Tag patch as Forwarded: not-needed
  * Install pkgconfig to multi-arch destination
  * Enable Salsa CI
  * Bump copyrights
  * Enable symbol tracking
  * libwhisper-dev does not need ${misc:Depends}

 -- Christian Kastner <ckk@debian.org>  Sun, 11 Jan 2026 16:47:30 +0100

whisper.cpp (1.8.2+dfsg-3) unstable; urgency=medium

  [ Mathieu Baudier ]
  * Work around missing macro after ggml v0.9.5 upgrade
  * Adapt to ggml now being a public library
  * Build debug info
  * Use debian/unstable branch instead of master

  [ Christian Kastner ]
  * Bump libggml-dev dependency to 0.9.5.

 -- Mathieu Baudier <mbaudier@argeo.org>  Sat, 03 Jan 2026 16:30:16 +0000

whisper.cpp (1.8.2+dfsg-2) experimental; urgency=medium

  * Refresh d/copyright
  * Generalize lintian overrides

 -- Christian Kastner <ckk@debian.org>  Wed, 31 Dec 2025 11:40:54 +0100

whisper.cpp (1.8.2+dfsg-1) experimental; urgency=medium

  * New upstream version 1.8.2+dfsg
  * Adapt dependencies to changes in ggml Debian packaging
  * Disable talk-llama in order to have a more robust dependency to ggml APIs

 -- Mathieu Baudier <mbaudier@argeo.org>  Tue, 23 Dec 2025 12:29:18 +0000
