=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%$1.tar.gz%,dversionmangle=auto,repacksuffix=+dfsg" \
   https://github.com/ggml-org/whisper.cpp/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
