=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
                debhelper-compat (= 13),
                libsdl2-dev,
                libggml-dev (>= 0.9.5),
+               ffmpeg,
 Standards-Version: 4.7.3
 Homepage: https://github.com/ggml-org/whisper.cpp/
 Rules-Requires-Root: no
